



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>AI 行为树</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">AI 行为树</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 09:04:23 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>by AKara 2010-12-09 @ <a href="http://blog.csdn.net/akara" rel="external nofollow noreferrer">http://blog.csdn.net/akara</a> @ akarachen(at)gmail.com @<a href="http://weibo.com/akaras" rel="external nofollow noreferrer">weibo.com/akaras</a></p>
<p>谈到游戏AI，很明显智能体拥有的知识条目越多，便显得更智能，但维护<br />庞大数量的知识条目是个噩梦：使用有限状态机(FSM)，分层有限状态机(HFSM)，<br />决策树(Decision Tree)来实现游戏AI总有那么些不顺意。</p>
<p>试试Next-Gen AI的<strong> 行为树(Behavior Tree)</strong> 吧。</p>
<p>虽说Next-Gen AI，但距其原型提出已有约10年时间，而Halo系列(HFSM like)，<br />Spore，Crysis 2，Red Dead Redemption等早已用行为树作为它们的AI结构。<br />如从未接触，那wikipedia(http://en.wikipedia.org/wiki/Behavior_Trees)<br />绝对是入门好资料。</p>
<p>---------------------------------------------------------------------</p>
<p>先贴本文最具价值图(配色可花了不少时间)</p>
<p><img referrerpolicy="no-referrer"src="http://hi.csdn.net/attachment/201012/12/213345_1292157838h3CY.jpg" /></p>
<p>为显美观：BT被横放，Node层次被刻意减少，Dec被刻意安插，Cond被刻意捏造。<br />&nbsp; PS：其实真正的高效的Node Group剔除应多加一层Sequence Node。<br />&nbsp; <br />---------------------------------------------------------------------</p>
<p><strong>行为树(Behavior Tree)</strong> 具有如下的特性：<br />&nbsp; <br />&nbsp; 它只有4大类型的Node：<br />&nbsp; * <strong>Composite Node</strong><br />&nbsp; * <strong>Decorator Node</strong><br />&nbsp; * <strong>Condition Node</strong><br />&nbsp; * <strong>Action Node</strong><br />&nbsp; <br />&nbsp; 任何Node被执行后，必须向其Parent Node报告执行结果：成功 / 失败。<br />&nbsp; 这简单的成功 / 失败汇报原则被很巧妙地用于控制整棵树的决策方向。</p>
<p>---------------------------------------------------------------------<br />&nbsp; <br />&nbsp; 先看<strong>Composite Node</strong>，其实它按复合性质还可以细分为3种：<br />&nbsp; * <strong>Selector Node</strong><br />&nbsp;&nbsp;&nbsp; 当执行本类型Node时，它将从begin到end迭代执行自己的Child Node：<br />&nbsp;&nbsp;&nbsp; 如遇到一个Child Node执行后返回True，那停止迭代，<br />&nbsp;&nbsp;&nbsp; 本Node向自己的Parent Node也返回True；否则所有Child Node都返回False，<br />&nbsp;&nbsp;&nbsp; 那本Node向自己的Parent Node返回False。<br />&nbsp;&nbsp;&nbsp; <br />&nbsp; * <strong>Sequence Node</strong><br />&nbsp;&nbsp;&nbsp; 当执行本类型Node时，它将从begin到end迭代执行自己的Child Node：<br />&nbsp;&nbsp;&nbsp; 如遇到一个Child Node执行后返回False，那停止迭代，<br />&nbsp;&nbsp;&nbsp; 本Node向自己的Parent Node也返回False；否则所有Child Node都返回True，<br />&nbsp;&nbsp;&nbsp; 那本Node向自己的Parent Node返回True。<br />&nbsp; <br />&nbsp; * <strong>Parallel Node</strong><br />&nbsp;&nbsp;&nbsp; 平行执行它的所有Child Node。<br />&nbsp;&nbsp;&nbsp; 而向Parent Node返回的值和Parallel Node所采取的具体策略相关：<br />&nbsp;&nbsp;&nbsp; Parallel Selector Node: 一False则返回False，全True才返回True。<br />&nbsp;&nbsp;&nbsp; Parallel Sequence Node: 一True则返回True，全False才返回False。<br />&nbsp;&nbsp;&nbsp; Parallel Fall On All Node: 所有False才返回False，否则返回True。<br />&nbsp;&nbsp;&nbsp; Parallel Succeed On All Node: 所有True才返回True，否则返回False。<br />&nbsp;&nbsp;&nbsp; Parallel Hybird Node: 指定数量的Child Node返回True或False后才决定结果。</p>
<p>Parallel Node提供了平行的概念。<br />&nbsp;&nbsp;&nbsp; 不需要像Selector/Sequence那样预判哪个Child Node应摆前，哪个应摆后，<br />&nbsp;&nbsp;&nbsp; 常见情况是：<br />&nbsp;&nbsp;&nbsp; (1)用于平行挂接多棵Action子树。<br />&nbsp;&nbsp;&nbsp; (2)在Parallel Node下挂一棵子树，并挂上多个Condition Node，<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 以提供实时性和性能。<br />&nbsp;&nbsp;&nbsp; Parallel Node增加方便性的同时，也增加实现和维护复杂度。</p>
<p>PS：上面的Selector/Sequence准确来说是Liner Selector/Liner Sequence。<br />&nbsp; AI术语中称为strictly-order：按既定先后顺序迭代。<br />&nbsp; <br />&nbsp; Selector和Sequence可以进一步提供非线性迭代的加权随机变种。<br />&nbsp; Weight Random Selector Node提供每次执行不同First True Child Node的功能。<br />&nbsp; Weight Random Probability Node提供每次挑选唯一一个Node的功能。<br />&nbsp; Weight Random Sequence Node则提供每次不同的迭代顺序。<br />&nbsp; AI术语中称为partial-order，能使AI避免总出现可预期的结果。</p>
<p>---------------------------------------------------------------------</p>
<p>再看<strong>Decorator Node</strong>，它的功能正如它的字面意思：它将它的Child Node执行<br />&nbsp; 后返回的结果值做额外处理后，再返回给它的Parent Node。很有些AOP的味道。<br />&nbsp; <br />&nbsp; 比如Decorator Not/Decorator FailUtil/Decorator Counter/Decorator Time...<br />&nbsp; 更geek的有Decorator Log/Decorator Ani/Decorator Nothing...</p>
<p>---------------------------------------------------------------------<br />&nbsp;<br />&nbsp; 然后是很直白的<strong>Condition Node</strong>，它仅当满足Condition时返回True。</p>
<p>---------------------------------------------------------------------<br />&nbsp; <br />&nbsp; 最后看<strong>Action Node</strong>，它完成具体的一次(或一个step)的行为，视需求返回值。<br />&nbsp; 而当行为需要分step/Node间进行时，可引入<strong>Blackboard</strong>进行简单数据交互。<br />&nbsp; <br />---------------------------------------------------------------------&nbsp; <br />&nbsp; <br />&nbsp; 整棵行为树中，只有Condition Node和Action Node才能成为Leaf Node，而也<br />只有Leaf Node才是需要特别定制的Node；Composite Node和Decorator Node均<br />用于控制行为树中的决策走向。(所以有些资料中也统称Condition Node和Action<br />Node为Behavior Node，而Composite Node和Decorator Node为Decider Node。)<br />&nbsp; <br />&nbsp; 更强大的是可以加入<strong>Stimulus</strong>和<strong>Impulse</strong>，通过Precondition来判断masks开关。<br />&nbsp; <br />&nbsp; 通过上述的各种Nodes几乎可以实现所有的决策控制：if, while, and, or, <br />not, counter, time, random, weight random, util...<br />&nbsp;<br />---------------------------------------------------------------------</p>
<p>总的来说，行为树具有如下几种优点，确实是实现AI框架的利器，甚至是一种<br />通用的可维护的复杂流程管理利器：</p>
<p>&gt; <strong>静态性</strong><br />&nbsp; 越复杂的功能越需要简单的基础，否则最后连自己都玩不过来。<br />&nbsp; <br />&nbsp; 静态是使用行为树需要非常着重的一个要点：即使系统需要某些"动态"性。<br />&nbsp; <br />&nbsp; 其实诸如Stimulus这类动态安插的Node看似强大，<br />&nbsp; 但却破坏了本来易于理解的静态性，弊大于利。<br />&nbsp; Halo3相对于Halo2对BT AI的一个改进就是去除Stimulus的动态性。<br />&nbsp; 取而代之的做法是使用Behavior Masks，Encounter Attitude，Inhibitions。<br />&nbsp; 原则就是保持全部Node静态，只是根据事件和环境来检查是否启用Node。<br />&nbsp; <br />&nbsp; 静态性直接带来的好处就是整棵树的规划无需再运行时动态调整，为很多优化<br />&nbsp; 和预编辑都带来方便。</p>
<p>&gt; <strong>直观性</strong><br />&nbsp; 行为树可以方便地把复杂的AI知识条目组织得非常直观。<br />&nbsp; 默认的Composite Node的从begin往end的Child Node迭代方式就像是处理一个<br />&nbsp; 预设优先策略队列，也非常符合人类的正常思考模式：先最优再次优。<br />&nbsp; <br />&nbsp; 行为树编辑器对优秀的程序员来说也是唾手可得。</p>
<p>&gt; <strong>复用性</strong><br />&nbsp; 各种Node，包括Leaf Node，可复用性都极高。<br />&nbsp; 实现NPC AI的个性区别甚至可以通过在一棵共用的行为树上不同的位置来<br />&nbsp; 安插Impulse来达到目的。<br />&nbsp; <br />&nbsp; 当然，当NPC需要一个完全不同的大脑，比如70级大BOSS，<br />&nbsp; 与其绞尽脑汁在一棵公用BT安插Impulse，不如重头设计一棵专属BT。</p>
<p>&gt; <strong>扩展性</strong><br />&nbsp; 虽然上述Node之间的组合和搭配使用几乎覆盖所有AI需求。<br />&nbsp; 但也可以容易地为项目量身定做新的Composite Node或Decorator Node。<br />&nbsp; 还可以积累一个项目相关的Node Lib，长远来说非常有价值。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8ex2xq1.html">关于CommonJS规范摘录</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rd17m8.html">winform 用户控件、 动态创建添加控件、timer控件、控件联动</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g554z8.html">集成ShareSDK，分享成功后QQ和空间回调不执行的可能原因</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z6x51q.html">CentOS7 bonding配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1wye29.html">LINQ的Intersect方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwezrzq.html">java写文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwmm5r8.html">jsp打印页面 js代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g77g09.html">BST、B树、B&plus;树、B&ast;树</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oe0ve9.html">Asp&period;net Request方法获取客户端的信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z2wyz9.html">&lbrack;CODEVS1258&rsqb;关路灯</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yvjy3q.html">&lbrack;BZOJ 1048&rsqb; &lbrack;HAOI2007&rsqb; 分割矩阵 【记忆化搜索】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1gemj9.html">border属性妙用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m5wzjq.html">C&num;&amp;amp&semi;Sql获取中文字符拼音首字母的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn17z7x8.html">Intel 编译Boost库</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vzg2n8.html">JQuery&amp;gt&semi;&amp;gt&semi;&amp;gt&semi;get&sol;post赋值全局变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn13ddx8.html">3D 转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1p2xj9.html">perl 爬取同花顺数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj46dxq.html">对adapter的封装优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1ky7m59.html">从Leetcode的Combination Sum系列谈起回溯法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gexxwl8.html">c语言文件分割与合并</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwdr53k8.html">混乱的url编码&vert;&vert;URL编码解码问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyd54mdq.html">CentOS7 安装 PostGIS方法（适合国内网络</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxn5enj8.html">Codeforces Round &num;222 &lpar;Div&period; 1&rpar; C&period; Captains Mode 对弈&plus;dp</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yknl5q.html">【UVA】【11021】麻球繁衍</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4ykdnjq.html">WP 类似扑克牌布局控件和类似扑克卡片控件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z146jx9.html">script是什么</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xv37g9.html">仪表盘 hostmap 新玩法让运维工作越玩越 high</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mg0v1q.html">Url重写和伪静态</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdezrnx9.html">https 方式使用git&commat;osc设置密码的方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj3vpy9.html">Ubuntu环境下手动配置HBase0&period;94&period;25</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
